"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsdom_1 = require("@forbeslindesay/jsdom");
var whatwg_url_1 = require("whatwg-url");
var StorageShim = require("node-storage-shim");
var Tab = (function () {
    function Tab(browser, options, id, localStorage, onClose) {
        var _this = this;
        this._sessionStorage = new Map();
        this._beforeParse = function (window) {
            // polyfill local storage
            var host = window.location.host;
            var sessionStorage = _this._sessionStorage.get(host) || new StorageShim();
            var localStorage = _this._localStorage.get(host) || new StorageShim();
            _this._sessionStorage.set(host, sessionStorage);
            _this._localStorage.set(host, localStorage);
            window.sessionStorage = sessionStorage;
            window.localStorage = localStorage;
            // polyfill console.dir
            window.console.dir = window.console.log;
            // polyfill requestAnimationFrame and cancelAnimationFrame
            var lastTime = 0;
            if (!window.requestAnimationFrame)
                window.requestAnimationFrame = function (callback, element) {
                    var currTime = new Date().getTime();
                    var timeToCall = Math.max(0, 16 - (currTime - lastTime));
                    var id = window.setTimeout(function () { callback(currTime + timeToCall); }, timeToCall);
                    lastTime = currTime + timeToCall;
                    return id;
                };
            if (!window.cancelAnimationFrame)
                window.cancelAnimationFrame = function (id) {
                    clearTimeout(id);
                };
            _this._browser.onBeforeParse.emit(window);
        };
        this._browser = browser;
        this.id = id;
        this.name = options.name;
        this._localStorage = localStorage;
        this._onClose = onClose;
        this.setLocation(options);
    }
    Tab.prototype.setLocation = function (options) {
        var url = whatwg_url_1.parseURL(options.url);
        if (url === 'failure') {
            throw new Error('Invalid url ' + options.url);
        }
        this._url = url;
        if (url.scheme === 'about') {
            this._dom = Promise.resolve(new jsdom_1.JSDOM('', {
                cookieJar: this._browser.cookies,
                url: options.url,
                referrer: options.referrer,
                resources: 'usable',
                runScripts: this._browser.runScripts,
                beforeParse: this._beforeParse,
            }));
        }
        else {
            this._dom = jsdom_1.JSDOM.fromURL(options.url, {
                cookieJar: this._browser.cookies,
                referrer: options.referrer,
                resources: 'usable',
                runScripts: this._browser.runScripts,
                beforeParse: this._beforeParse,
            });
        }
    };
    Object.defineProperty(Tab.prototype, "dom", {
        get: function () {
            return this._dom;
        },
        enumerable: true,
        configurable: true
    });
    Tab.prototype.whenReady = function () {
        return this._dom.then(function (dom) {
            var state = dom.window.document.readyState;
            if (state === 'complete' || state === 'interactive') {
                return dom;
            }
            return new Promise(function (resolve, reject) {
                dom.window.document.addEventListener('DOMContentLoaded', function () { return resolve(dom); });
            });
        });
    };
    Tab.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var dom;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.dom];
                    case 1:
                        dom = _a.sent();
                        dom.window.close();
                        this._onClose(this);
                        return [2 /*return*/];
                }
            });
        });
    };
    return Tab;
}());
exports.default = Tab;
