"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var methods = [];
function register(method, path, fn) {
    methods.push({ method: method, path: path, fn: fn });
}
register("post" /* post */, '/session', 'createSession');
register("delete" /* delete */, '/session/:sessionId', 'deleteSession');
register("delete" /* delete */, '/session/:sessionId/cookie', 'deleteAllCookies');
register("delete" /* delete */, '/session/:sessionId/cookie/:key', 'deleteCookie');
register("get" /* get */, '/session/:sessionId/element/:elementA/equals/:elementB', 'compareElements');
register("get" /* get */, '/session/:sessionId/window_handle', 'getActiveWindowHandle');
register("post" /* post */, '/session/:sessionId/timeouts', 'setTimeouts');
register("post" /* post */, '/session/:sessionId/timeouts/async_script', 'setAsyncScriptTimeOut');
register("post" /* post */, '/session/:sessionId/url', 'setUrl');
register("get" /* get */, '/session/:sessionId/url', 'getUrl');
register("post" /* post */, '/session/:sessionId/element', 'getElement');
register("post" /* post */, '/session/:sessionId/element/active', 'getActiveElement');
register("post" /* post */, '/session/:sessionId/elements', 'getElements');
register("get" /* get */, '/session/:sessionId/element/:elementId/name', 'getTagName');
register("get" /* get */, '/session/:sessionId/element/:elementId/attribute/:attributeName', 'getAttribute');
register("get" /* get */, '/session/:sessionId/element/:elementId/css/:propertyName', 'getCssProperty');
register("get" /* get */, '/session/:sessionId/element/:elementId/enabled', 'getEnabled');
register("get" /* get */, '/session/:sessionId/element/:elementId/selected', 'getSelected');
register("get" /* get */, '/session/:sessionId/element/:elementId/text', 'getText');
register("post" /* post */, '/session/:sessionId/element/:elementId/click', 'click');
register("post" /* post */, '/session/:sessionId/element/:elementId/submit', 'submit');
register("post" /* post */, '/session/:sessionId/element/:elementId/clear', 'clear');
register("post" /* post */, '/session/:sessionId/element/:elementId/value', 'appendValue');
register("get" /* get */, '/session/:sessionId/element/:elementId/displayed', 'getDisplayed');
register("post" /* post */, '/session/:sessionId/moveto', 'moveTo');
register("post" /* post */, '/session/:sessionId/click', 'globalClick');
register("post" /* post */, '/session/:sessionId/element/:elementId/element', 'getChildElement');
register("post" /* post */, '/session/:sessionId/element/:elementId/elements', 'getChildElements');
register("get" /* get */, '/session/:sessionId/title', 'getTitle');
register("get" /* get */, '/session/:sessionId/source', 'getSource');
register("post" /* post */, '/session/:sessionId/keys', 'sendKeys');
register("post" /* post */, '/session/:sessionId/back', 'goBack');
register("post" /* post */, '/session/:sessionId/forward', 'goForward');
register("post" /* post */, '/session/:sessionId/refresh', 'refresh');
register("post" /* post */, '/session/:sessionId/execute', 'execute');
register("post" /* post */, '/session/:sessionId/execute_async', 'executeAsync');
register("post" /* post */, '/session/:sessionId/cookie', 'setCookie');
register("get" /* get */, '/session/:sessionId/cookie', 'getCookies');
register("post" /* post */, '/session/:sessionId/:storageLevel', 'setStorageItem');
register("get" /* get */, '/session/:sessionId/:storageLevel', 'getStorageKeys');
register("get" /* get */, '/session/:sessionId/:storageLevel/key/:key', 'getStorageItem');
register("get" /* get */, '/session/:sessionId/:storageLevel/size', 'getStorageSize');
register("delete" /* delete */, '/session/:sessionId/:storageLevel', 'clearStorage');
register("delete" /* delete */, '/session/:sessionId/:storageLevel/key/:key', 'removeStorageItem');
register("delete" /* delete */, '/session/:sessionId/window', 'closeActiveWindow');
exports.default = methods;
