"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function eventChannel() {
    var handlers = new Set();
    function on(handler) {
        handlers.add(handler);
        return function () {
            handlers.delete(handler);
        };
    }
    on.emit = function (value) {
        handlers.forEach(function (fn) { return fn(value); });
    };
    return on;
}
exports.default = eventChannel;
